Index: src/parser.cpp
===================================================================
--- src/parser.cpp	(revision 8c54a3b5f6bdf770309a91dff75fb62f47d91b6d)
+++ src/parser.cpp	(revision 0dbddc24a89f547aa564634e7647f87ec8ce9700)
@@ -24,14 +24,14 @@
 bool FilePresent(const char *filename, bool test)
 {
-	ifstream input;
-
-	input.open(filename, ios::in);
-	if (input == NULL) {
-		if (!test)
-			cout << endl << "Unable to open " << filename << ", is the directory correct?" << endl;
-		return false;
-	}
-	input.close();
-	return true;
+  ifstream input;
+
+  input.open(filename, ios::in);
+  if (input == NULL) {
+    if (!test)
+      cout << endl << "Unable to open " << filename << ", is the directory correct?" << endl;
+    return false;
+  }
+  input.close();
+  return true;
 };
 
@@ -43,9 +43,9 @@
 bool TestParams(int argc, char **argv)
 {
-	ifstream input;
-	stringstream line;
-
-	line << argv[1] << FRAGMENTPREFIX << KEYSETFILE;
-	return FilePresent(line.str().c_str(), false);
+  ifstream input;
+  stringstream line;
+
+  line << argv[1] << FRAGMENTPREFIX << KEYSETFILE;
+  return FilePresent(line.str().c_str(), false);
 };
 
@@ -55,12 +55,14 @@
  */
 MatrixContainer::MatrixContainer() {
-	Indices = NULL;
-	Header = (char *) Malloc(sizeof(char)*1023, "MatrixContainer::MatrixContainer: *Header");
-	Matrix = (double ***) Malloc(sizeof(double **)*(1), "MatrixContainer::MatrixContainer: ***Matrix"); // one more each for the total molecule
-	RowCounter = (int *) Malloc(sizeof(int)*(1), "MatrixContainer::MatrixContainer: *RowCounter");
-	Matrix[0] = NULL;
-	RowCounter[0] = -1;
-	MatrixCounter = 0;
-	ColumnCounter = 0;
+  Indices = NULL;
+  Header = (char **) Malloc(sizeof(char)*1, "MatrixContainer::MatrixContainer: **Header");
+  Matrix = (double ***) Malloc(sizeof(double **)*(1), "MatrixContainer::MatrixContainer: ***Matrix"); // one more each for the total molecule
+  RowCounter = (int *) Malloc(sizeof(int)*(1), "MatrixContainer::MatrixContainer: *RowCounter");
+  ColumnCounter = (int *) Malloc(sizeof(int)*(1), "MatrixContainer::MatrixContainer: *ColumnCounter");
+  Header[0] = NULL;
+  Matrix[0] = NULL;
+  RowCounter[0] = -1;
+  MatrixCounter = 0;
+  ColumnCounter[0] = -1;
 };
 
@@ -68,37 +70,75 @@
  */
 MatrixContainer::~MatrixContainer() {
-	if (Matrix != NULL) {
-		for(int i=MatrixCounter;i--;) {
-			if (RowCounter != NULL) {
-					for(int j=RowCounter[i]+1;j--;)
-						Free((void **)&Matrix[i][j], "MatrixContainer::~MatrixContainer: *Matrix[][]");
-				Free((void **)&Matrix[i], "MatrixContainer::~MatrixContainer: **Matrix[]");
-			}
-		}
-		if ((RowCounter != NULL) && (Matrix[MatrixCounter] != NULL))
-			for(int j=RowCounter[MatrixCounter]+1;j--;)
-				Free((void **)&Matrix[MatrixCounter][j], "MatrixContainer::~MatrixContainer: *Matrix[MatrixCounter][]");
-		if (MatrixCounter != 0)
-			Free((void **)&Matrix[MatrixCounter], "MatrixContainer::~MatrixContainer: **Matrix[MatrixCounter]");
-		Free((void **)&Matrix, "MatrixContainer::~MatrixContainer: ***Matrix");
-	}
-	if (Indices != NULL)
-		for(int i=MatrixCounter+1;i--;) {
-			Free((void **)&Indices[i], "MatrixContainer::~MatrixContainer: *Indices[]");
-		}
-	Free((void **)&Indices, "MatrixContainer::~MatrixContainer: **Indices");
-
-	Free((void **)&Header, "MatrixContainer::~MatrixContainer: *Header");
-	Free((void **)&RowCounter, "MatrixContainer::~MatrixContainer: *RowCounter");
-};
-
+  if (Matrix != NULL) {
+    for(int i=MatrixCounter;i--;) {
+      if ((ColumnCounter != NULL) && (RowCounter != NULL)) {
+          for(int j=RowCounter[i]+1;j--;)
+            Free((void **)&Matrix[i][j], "MatrixContainer::~MatrixContainer: *Matrix[][]");
+        Free((void **)&Matrix[i], "MatrixContainer::~MatrixContainer: **Matrix[]");
+      }
+    }
+    if ((ColumnCounter != NULL) && (RowCounter != NULL) && (Matrix[MatrixCounter] != NULL))
+      for(int j=RowCounter[MatrixCounter]+1;j--;)
+        Free((void **)&Matrix[MatrixCounter][j], "MatrixContainer::~MatrixContainer: *Matrix[MatrixCounter][]");
+    if (MatrixCounter != 0)
+      Free((void **)&Matrix[MatrixCounter], "MatrixContainer::~MatrixContainer: **Matrix[MatrixCounter]");
+    Free((void **)&Matrix, "MatrixContainer::~MatrixContainer: ***Matrix");
+  }
+  if (Indices != NULL)
+    for(int i=MatrixCounter+1;i--;) {
+      Free((void **)&Indices[i], "MatrixContainer::~MatrixContainer: *Indices[]");
+    }
+  Free((void **)&Indices, "MatrixContainer::~MatrixContainer: **Indices"); 
+  
+  if (Header != NULL)
+    for(int i=MatrixCounter+1;i--;)
+      Free((void **)&Header[i], "MatrixContainer::~MatrixContainer: *Header[]");
+  Free((void **)&Header, "MatrixContainer::~MatrixContainer: **Header");
+  Free((void **)&RowCounter, "MatrixContainer::~MatrixContainer: *RowCounter");
+  Free((void **)&ColumnCounter, "MatrixContainer::~MatrixContainer: *RowCounter");
+};
+
+/** Either copies index matrix from another MatrixContainer or initialises with trivial mapping if NULL.
+ * This either copies the index matrix or just maps 1 to 1, 2 to 2 and so on for all fragments.
+ * \param *Matrix pointer to other MatrixContainer
+ * \return true - copy/initialisation sucessful, false - dimension false for copying
+ */
+bool MatrixContainer::InitialiseIndices(class MatrixContainer *Matrix) 
+{
+  cout << "Initialising indices";
+  if (Matrix == NULL) {
+    cout << " with trivial mapping." << endl;
+    Indices = (int **) Malloc(sizeof(int *)*(MatrixCounter+1), "MatrixContainer::InitialiseIndices: **Indices");
+    for(int i=MatrixCounter+1;i--;) {
+      Indices[i] = (int *) Malloc(sizeof(int)*RowCounter[i], "MatrixContainer::InitialiseIndices: *Indices[]");
+      for(int j=RowCounter[i];j--;)
+        Indices[i][j] = j;
+    }
+  } else {
+    cout << " from other MatrixContainer." << endl;
+    if (MatrixCounter != Matrix->MatrixCounter)
+      return false;
+    Indices = (int **) Malloc(sizeof(int *)*(MatrixCounter+1), "MatrixContainer::InitialiseIndices: **Indices");
+    for(int i=MatrixCounter+1;i--;) {
+      if (RowCounter[i] != Matrix->RowCounter[i])
+        return false;
+      Indices[i] = (int *) Malloc(sizeof(int)*Matrix->RowCounter[i], "MatrixContainer::InitialiseIndices: *Indices[]");
+      for(int j=Matrix->RowCounter[i];j--;) {
+        Indices[i][j] = Matrix->Indices[i][j];
+        //cout << Indices[i][j] << "\t";
+      }
+      //cout << endl;
+    }
+  }
+  return true; 
+};
 
 /** Parsing a number of matrices.
- *		-# open the matrix file
- *		-# skip some lines (\a skiplines)
- *		-# scan header lines for number of columns
- *		-# scan lines for number of rows
- *		-# allocate matrix
- *		-# loop over found column and row counts and parse in each entry
+ *    -# open the matrix file
+ *    -# skip some lines (\a skiplines)
+ *    -# scan header lines for number of columns
+ *    -# scan lines for number of rows
+ *    -# allocate matrix
+ *    -# loop over found column and row counts and parse in each entry
  * \param *name directory with files
  * \param skiplines number of inital lines to skip
@@ -109,83 +149,84 @@
 bool MatrixContainer::ParseMatrix(const char *name, int skiplines, int skipcolumns, int MatrixNr)
 {
-	ifstream input;
-	stringstream line;
-	string token;
-	char filename[1023];
-
-	input.open(name, ios::in);
-	//cout << "Opening " << name << " ... "	<< input << endl;
-	if (input == NULL) {
-		cerr << endl << "Unable to open " << name << ", is the directory correct?" << endl;
-		return false;
-	}
-
-	// skip some initial lines
-	for (int m=skiplines+1;m--;)
-		input.getline(Header, 1023);
-
-	// scan header for number of columns
-	line.str(Header);
-	for(int k=skipcolumns;k--;)
-		line >> Header;
-	//cout << line.str() << endl;
-	ColumnCounter=0;
-	while ( getline(line,token, '\t') ) {
-		if (token.length() > 0)
-			ColumnCounter++;
-	}
-	//cout << line.str() << endl;
-	//cout << "ColumnCounter: " << ColumnCounter << "." << endl;
-	if (ColumnCounter == 0)
-		cerr << "ColumnCounter: " << ColumnCounter << " from file " << name << ", this is probably an error!" << endl;
-
-	// scan rest for number of rows/lines
-	RowCounter[MatrixNr]=-1;		// counts one line too much
-	while (!input.eof()) {
-		input.getline(filename, 1023);
-		//cout << "Comparing: " << strncmp(filename,"MeanForce",9) << endl;
-		RowCounter[MatrixNr]++; // then line was not last MeanForce
-		if (strncmp(filename,"MeanForce", 9) == 0) {
-			break;
-		}
-	}
-	//cout << "RowCounter[" << MatrixNr << "]: " << RowCounter[MatrixNr] << " from file " << name << "." << endl;
-	if (RowCounter[MatrixNr] == 0)
-		cerr << "RowCounter[" << MatrixNr << "]: " << RowCounter[MatrixNr] << " from file " << name << ", this is probably an error!" << endl;
-
-	// allocate matrix if it's not zero dimension in one direction
-	if ((ColumnCounter > 0) && (RowCounter[MatrixNr] > -1)) {
-		Matrix[MatrixNr] = (double **) Malloc(sizeof(double *)*(RowCounter[MatrixNr]+1), "MatrixContainer::ParseFragmentMatrix: **Matrix[]");
-
-		// parse in each entry for this matrix
-		input.clear();
-		input.seekg(ios::beg);
-		for (int m=skiplines+1;m--;)
-			input.getline(Header, 1023);		// skip header
-		line.str(Header);
-		for(int k=skipcolumns;k--;)	// skip columns in header too
-			line >> filename;
-		strncpy(Header, line.str().c_str(), 1023);
-		for(int j=0;j<RowCounter[MatrixNr];j++) {
-			Matrix[MatrixNr][j] = (double *) Malloc(sizeof(double)*ColumnCounter, "MatrixContainer::ParseFragmentMatrix: *Matrix[][]");
-			input.getline(filename, 1023);
-			stringstream lines(filename);
-			//cout << "Matrix at level " << j << ":";// << filename << endl;
-			for(int k=skipcolumns;k--;)
-				lines >> filename;
-			for(int k=0;(k<ColumnCounter) && (!lines.eof());k++) {
-				lines >> Matrix[MatrixNr][j][k];
-				//cout << " " << setprecision(2) << Matrix[MatrixNr][j][k];;
-			}
-			//cout << endl;
-			Matrix[MatrixNr][ RowCounter[MatrixNr] ] = (double *) Malloc(sizeof(double)*ColumnCounter, "MatrixContainer::ParseFragmentMatrix: *Matrix[RowCounter[MatrixNr]][]");
-			for(int j=ColumnCounter;j--;)
-				Matrix[MatrixNr][ RowCounter[MatrixNr] ][j] = 0.;
-		}
-	} else {
-		cerr << "ERROR: Matrix nr. " << MatrixNr << " has column and row count of (" << ColumnCounter << "," << RowCounter[MatrixNr] << "), could not allocate nor parse!" << endl;
-	}
-	input.close();
-	return true;
+  ifstream input;
+  stringstream line;
+  string token;
+  char filename[1023];
+
+  input.open(name, ios::in);
+  //cout << "Opening " << name << " ... "  << input << endl;
+  if (input == NULL) {
+    cerr << endl << "Unable to open " << name << ", is the directory correct?" << endl;
+    return false;
+  }
+
+  // parse header
+  Header[MatrixNr] = (char *) Malloc(sizeof(char)*1024, "MatrixContainer::ParseMatrix: *Header[]");
+  for (int m=skiplines+1;m--;)
+    input.getline(Header[MatrixNr], 1023);
+  
+  // scan header for number of columns
+  line.str(Header[MatrixNr]);
+  for(int k=skipcolumns;k--;)
+    line >> Header[MatrixNr];
+  //cout << line.str() << endl;
+  ColumnCounter[MatrixNr]=0;
+  while ( getline(line,token, '\t') ) {
+    if (token.length() > 0)
+      ColumnCounter[MatrixNr]++;
+  }
+  //cout << line.str() << endl;
+  //cout << "ColumnCounter[" << MatrixNr << "]: " << ColumnCounter[MatrixNr] << "." << endl;
+  if (ColumnCounter[MatrixNr] == 0)
+    cerr << "ColumnCounter[" << MatrixNr << "]: " << ColumnCounter[MatrixNr] << " from file " << name << ", this is probably an error!" << endl;
+  
+  // scan rest for number of rows/lines
+  RowCounter[MatrixNr]=-1;    // counts one line too much
+  while (!input.eof()) {
+    input.getline(filename, 1023);
+    //cout << "Comparing: " << strncmp(filename,"MeanForce",9) << endl;
+    RowCounter[MatrixNr]++; // then line was not last MeanForce
+    if (strncmp(filename,"MeanForce", 9) == 0) {
+      break;
+    }
+  }
+  //cout << "RowCounter[" << MatrixNr << "]: " << RowCounter[MatrixNr] << " from file " << name << "." << endl;
+  if (RowCounter[MatrixNr] == 0)
+    cerr << "RowCounter[" << MatrixNr << "]: " << RowCounter[MatrixNr] << " from file " << name << ", this is probably an error!" << endl;
+
+  // allocate matrix if it's not zero dimension in one direction
+  if ((ColumnCounter[MatrixNr] > 0) && (RowCounter[MatrixNr] > -1)) {
+    Matrix[MatrixNr] = (double **) Malloc(sizeof(double *)*(RowCounter[MatrixNr]+1), "MatrixContainer::ParseMatrix: **Matrix[]");
+  
+    // parse in each entry for this matrix
+    input.clear();
+    input.seekg(ios::beg);
+    for (int m=skiplines+1;m--;)
+      input.getline(Header[MatrixNr], 1023);    // skip header
+    line.str(Header[MatrixNr]);
+    for(int k=skipcolumns;k--;)  // skip columns in header too
+      line >> filename;
+    strncpy(Header[MatrixNr], line.str().c_str(), 1023);  
+    for(int j=0;j<RowCounter[MatrixNr];j++) {
+      Matrix[MatrixNr][j] = (double *) Malloc(sizeof(double)*ColumnCounter[MatrixNr], "MatrixContainer::ParseMatrix: *Matrix[][]");
+      input.getline(filename, 1023);
+      stringstream lines(filename);
+      //cout << "Matrix at level " << j << ":";// << filename << endl;
+      for(int k=skipcolumns;k--;)
+        lines >> filename;
+      for(int k=0;(k<ColumnCounter[MatrixNr]) && (!lines.eof());k++) {
+        lines >> Matrix[MatrixNr][j][k];
+        //cout << " " << setprecision(2) << Matrix[MatrixNr][j][k];;
+      }
+      //cout << endl;
+      Matrix[MatrixNr][ RowCounter[MatrixNr] ] = (double *) Malloc(sizeof(double)*ColumnCounter[MatrixNr], "MatrixContainer::ParseMatrix: *Matrix[RowCounter[MatrixNr]][]");
+      for(int j=ColumnCounter[MatrixNr];j--;)
+        Matrix[MatrixNr][ RowCounter[MatrixNr] ][j] = 0.;
+    }
+  } else {
+    cerr << "ERROR: Matrix nr. " << MatrixNr << " has column and row count of (" << ColumnCounter[MatrixNr] << "," << RowCounter[MatrixNr] << "), could not allocate nor parse!" << endl; 
+  }
+  input.close();
+  return true;
 };
 
@@ -193,11 +234,11 @@
  * -# First, count the number of matrices by counting lines in KEYSETFILE
  * -# Then,
- *		-# construct the fragment number
- *		-# open the matrix file
- *		-# skip some lines (\a skiplines)
- *		-# scan header lines for number of columns
- *		-# scan lines for number of rows
- *		-# allocate matrix
- *		-# loop over found column and row counts and parse in each entry
+ *    -# construct the fragment number
+ *    -# open the matrix file
+ *    -# skip some lines (\a skiplines)
+ *    -# scan header lines for number of columns
+ *    -# scan lines for number of rows
+ *    -# allocate matrix
+ *    -# loop over found column and row counts and parse in each entry
  * -# Finally, allocate one additional matrix (\a MatrixCounter) containing combined or temporary values
  * \param *name directory with files
@@ -210,71 +251,76 @@
 bool MatrixContainer::ParseFragmentMatrix(const char *name, const char *prefix, string suffix, int skiplines, int skipcolumns)
 {
-	char filename[1023];
-	ifstream input;
-	char *FragmentNumber = NULL;
-	stringstream file;
-	string token;
-
-	// count the number of matrices
-	MatrixCounter = -1; // we count one too much
-	file << name << FRAGMENTPREFIX << KEYSETFILE;
-	input.open(file.str().c_str(), ios::in);
-	if (input == NULL) {
-		cout << endl << "Unable to open " << file.str() << ", is the directory correct?" << endl;
-		return false;
-	}
-	while (!input.eof()) {
-		input.getline(filename, 1023);
-		stringstream zeile(filename);
-		MatrixCounter++;
-	}
-	input.close();
-	cout << "Determined " << MatrixCounter << " fragments." << endl;
-
-	cout << "Parsing through each fragment and retrieving " << prefix << suffix << "." << endl;
-	Matrix = (double ***) ReAlloc(Matrix, sizeof(double **)*(MatrixCounter+1), "MatrixContainer::ParseFragmentMatrix: ***Matrix"); // one more each for the total molecule
-	RowCounter = (int *) ReAlloc(RowCounter, sizeof(int)*(MatrixCounter+1), "MatrixContainer::ParseFragmentMatrix: *RowCounter");
-	for(int i=MatrixCounter+1;i--;) {
-		Matrix[i] = NULL;
-		RowCounter[i] = -1;
-	}
-	for(int i=0; i < MatrixCounter;i++) {
-		// open matrix file
-		FragmentNumber = FixedDigitNumber(MatrixCounter, i);
-		file.str(" ");
-		file << name << FRAGMENTPREFIX << FragmentNumber << prefix << suffix;
-		if (!ParseMatrix(file.str().c_str(), skiplines, skipcolumns, i))
-			return false;
-		Free((void **)&FragmentNumber, "MatrixContainer::ParseFragmentMatrix: *FragmentNumber");
-	}
-	return true;
+  char filename[1023];
+  ifstream input;
+  char *FragmentNumber = NULL;
+  stringstream file;
+  string token;
+
+  // count the number of matrices
+  MatrixCounter = -1; // we count one too much
+  file << name << FRAGMENTPREFIX << KEYSETFILE;
+  input.open(file.str().c_str(), ios::in);
+  if (input == NULL) {
+    cout << endl << "Unable to open " << file.str() << ", is the directory correct?" << endl;
+    return false;
+  }
+  while (!input.eof()) {
+    input.getline(filename, 1023);
+    stringstream zeile(filename);
+    MatrixCounter++;
+  }
+  input.close();
+  cout << "Determined " << MatrixCounter << " fragments." << endl;
+
+  cout << "Parsing through each fragment and retrieving " << prefix << suffix << "." << endl;
+  Header = (char **) ReAlloc(Header, sizeof(char *)*(MatrixCounter+1), "MatrixContainer::ParseFragmentMatrix: **Header"); // one more each for the total molecule
+  Matrix = (double ***) ReAlloc(Matrix, sizeof(double **)*(MatrixCounter+1), "MatrixContainer::ParseFragmentMatrix: ***Matrix"); // one more each for the total molecule
+  RowCounter = (int *) ReAlloc(RowCounter, sizeof(int)*(MatrixCounter+1), "MatrixContainer::ParseFragmentMatrix: *RowCounter");
+  ColumnCounter = (int *) ReAlloc(ColumnCounter, sizeof(int)*(MatrixCounter+1), "MatrixContainer::ParseFragmentMatrix: *ColumnCounter");
+  for(int i=MatrixCounter+1;i--;) {
+    Matrix[i] = NULL;
+    Header[i] = NULL;
+    RowCounter[i] = -1;
+    ColumnCounter[i] = -1;
+  }
+  for(int i=0; i < MatrixCounter;i++) {
+    // open matrix file
+    FragmentNumber = FixedDigitNumber(MatrixCounter, i);
+    file.str(" ");
+    file << name << FRAGMENTPREFIX << FragmentNumber << prefix << suffix;
+    if (!ParseMatrix(file.str().c_str(), skiplines, skipcolumns, i))
+      return false;
+    Free((void **)&FragmentNumber, "MatrixContainer::ParseFragmentMatrix: *FragmentNumber");
+  }
+  return true;
 };
 
 /** Allocates and resets the memory for a number \a MCounter of matrices.
- * \param *GivenHeader Header line
+ * \param **GivenHeader Header line for each matrix
  * \param MCounter number of matrices
  * \param *RCounter number of rows for each matrix
- * \param CCounter number of columns for all matrices
- * \return Allocation successful
- */
-bool MatrixContainer::AllocateMatrix(const char *GivenHeader, int MCounter, int *RCounter, int CCounter)
-{
-	Header = (char *) Malloc(sizeof(char)*1024, "MatrixContainer::ParseFragmentMatrix: *EnergyHeader");
-	strncpy(Header, GivenHeader, 1023);
-
-	MatrixCounter = MCounter;
-	ColumnCounter = CCounter;
-	Matrix = (double ***) Malloc(sizeof(double **)*(MatrixCounter+1), "MatrixContainer::ParseFragmentMatrix: ***Matrix"); // one more each for the total molecule
-	RowCounter = (int *) Malloc(sizeof(int)*(MatrixCounter+1), "MatrixContainer::ParseFragmentMatrix: *RowCounter");
-	for(int i=MatrixCounter+1;i--;) {
-		RowCounter[i] = RCounter[i];
-		Matrix[i] = (double **) Malloc(sizeof(double *)*(RowCounter[i]+1), "MatrixContainer::ParseFragmentMatrix: **Matrix[]");
-		for(int j=RowCounter[i]+1;j--;) {
-			Matrix[i][j] = (double *) Malloc(sizeof(double)*ColumnCounter, "MatrixContainer::ParseFragmentMatrix: *Matrix[][]");
-			for(int k=ColumnCounter;k--;)
-				Matrix[i][j][k] = 0.;
-		}
-	}
-	return true;
+ * \param *CCounter number of columns for each matrix
+ * \return Allocation successful 
+ */
+bool MatrixContainer::AllocateMatrix(char **GivenHeader, int MCounter, int *RCounter, int *CCounter)
+{
+  MatrixCounter = MCounter;
+  Header = (char **) Malloc(sizeof(char *)*(MatrixCounter+1), "MatrixContainer::AllocateMatrix: *Header");
+  Matrix = (double ***) Malloc(sizeof(double **)*(MatrixCounter+1), "MatrixContainer::AllocateMatrix: ***Matrix"); // one more each for the total molecule
+  RowCounter = (int *) Malloc(sizeof(int)*(MatrixCounter+1), "MatrixContainer::AllocateMatrix: *RowCounter");
+  ColumnCounter = (int *) Malloc(sizeof(int)*(MatrixCounter+1), "MatrixContainer::AllocateMatrix: *ColumnCounter");
+  for(int i=MatrixCounter+1;i--;) {
+    Header[i] = (char *) Malloc(sizeof(char)*1024, "MatrixContainer::AllocateMatrix: *Header[i]");
+    strncpy(Header[i], GivenHeader[i], 1023);
+    RowCounter[i] = RCounter[i];
+    ColumnCounter[i] = CCounter[i];
+    Matrix[i] = (double **) Malloc(sizeof(double *)*(RowCounter[i]+1), "MatrixContainer::AllocateMatrix: **Matrix[]");  
+    for(int j=RowCounter[i]+1;j--;) {
+      Matrix[i][j] = (double *) Malloc(sizeof(double)*ColumnCounter[i], "MatrixContainer::AllocateMatrix: *Matrix[][]");
+      for(int k=ColumnCounter[i];k--;)
+        Matrix[i][j][k] = 0.;
+    }
+  }
+  return true;
 };
 
@@ -284,9 +330,9 @@
 bool MatrixContainer::ResetMatrix()
 {
-	for(int i=MatrixCounter+1;i--;)
-		for(int j=RowCounter[i]+1;j--;)
-			for(int k=ColumnCounter;k--;)
-				Matrix[i][j][k] = 0.;
-	 return true;
+  for(int i=MatrixCounter+1;i--;)
+    for(int j=RowCounter[i]+1;j--;)
+      for(int k=ColumnCounter[i];k--;)
+        Matrix[i][j][k] = 0.;
+   return true;
 };
 
@@ -296,12 +342,12 @@
 double MatrixContainer::FindMaxValue()
 {
-	double max = Matrix[0][0][0];
-	for(int i=MatrixCounter+1;i--;)
-		for(int j=RowCounter[i]+1;j--;)
-			for(int k=ColumnCounter;k--;)
-				if (fabs(Matrix[i][j][k]) > max)
-					max = fabs(Matrix[i][j][k]);
-	if (fabs(max) < MYEPSILON)
-		max += MYEPSILON;
+  double max = Matrix[0][0][0];
+  for(int i=MatrixCounter+1;i--;)
+    for(int j=RowCounter[i]+1;j--;)
+      for(int k=ColumnCounter[i];k--;)
+        if (fabs(Matrix[i][j][k]) > max)
+          max = fabs(Matrix[i][j][k]);
+  if (fabs(max) < MYEPSILON)
+    max += MYEPSILON;
  return max;
 };
@@ -312,13 +358,13 @@
 double MatrixContainer::FindMinValue()
 {
-	double min = Matrix[0][0][0];
-	for(int i=MatrixCounter+1;i--;)
-		for(int j=RowCounter[i]+1;j--;)
-			for(int k=ColumnCounter;k--;)
-				if (fabs(Matrix[i][j][k]) < min)
-					min = fabs(Matrix[i][j][k]);
-	if (fabs(min) < MYEPSILON)
-		min += MYEPSILON;
-	return min;
+  double min = Matrix[0][0][0];
+  for(int i=MatrixCounter+1;i--;)
+    for(int j=RowCounter[i]+1;j--;)
+      for(int k=ColumnCounter[i];k--;)
+        if (fabs(Matrix[i][j][k]) < min)
+          min = fabs(Matrix[i][j][k]);
+  if (fabs(min) < MYEPSILON)
+    min += MYEPSILON;
+  return min;
 };
 
@@ -330,8 +376,8 @@
 bool MatrixContainer::SetLastMatrix(double value, int skipcolumns)
 {
-	for(int j=RowCounter[MatrixCounter]+1;j--;)
-		for(int k=skipcolumns;k<ColumnCounter;k++)
-			Matrix[MatrixCounter][j][k] = value;
-	 return true;
+  for(int j=RowCounter[MatrixCounter]+1;j--;)
+    for(int k=skipcolumns;k<ColumnCounter[MatrixCounter];k++)
+      Matrix[MatrixCounter][j][k] = value;
+   return true;
 };
 
@@ -343,13 +389,13 @@
 bool MatrixContainer::SetLastMatrix(double **values, int skipcolumns)
 {
-	for(int j=RowCounter[MatrixCounter]+1;j--;)
-		for(int k=skipcolumns;k<ColumnCounter;k++)
-			Matrix[MatrixCounter][j][k] = values[j][k];
-	 return true;
-};
-
-/** Sums the energy with each factor and put into last element of \a ***Energies.
+  for(int j=RowCounter[MatrixCounter]+1;j--;)
+    for(int k=skipcolumns;k<ColumnCounter[MatrixCounter];k++)
+      Matrix[MatrixCounter][j][k] = values[j][k];
+   return true;
+};
+
+/** Sums the entries with each factor and put into last element of \a ***Matrix.
  * Sums over "E"-terms to create the "F"-terms
- * \param Matrix MatrixContainer with matrices (LevelCounter by ColumnCounter) with all the energies.
+ * \param Matrix MatrixContainer with matrices (LevelCounter by *ColumnCounter) with all the energies.
  * \param KeySet KeySetContainer with bond Order and association mapping of each fragment to an order
  * \param Order bond order
@@ -358,49 +404,49 @@
 bool MatrixContainer::SumSubManyBodyTerms(class MatrixContainer &MatrixValues, class KeySetsContainer &KeySet, int Order)
 {
-	// go through each order
-	for (int CurrentFragment=0;CurrentFragment<KeySet.FragmentsPerOrder[Order];CurrentFragment++) {
-		//cout << "Current Fragment is " << CurrentFragment << "/" << KeySet.OrderSet[Order][CurrentFragment] << "." << endl;
-		// then go per order through each suborder and pick together all the terms that contain this fragment
-		for(int SubOrder=0;SubOrder<=Order;SubOrder++) { // go through all suborders up to the desired order
-			for (int j=0;j<KeySet.FragmentsPerOrder[SubOrder];j++) { // go through all possible fragments of size suborder
-				if (KeySet.Contains(KeySet.OrderSet[Order][CurrentFragment], KeySet.OrderSet[SubOrder][j])) {
-					//cout << "Current other fragment is " << j << "/" << KeySet.OrderSet[SubOrder][j] << "." << endl;
-					// if the fragment's indices are all in the current fragment
-					for(int k=0;k<RowCounter[ KeySet.OrderSet[SubOrder][j] ];k++) { // go through all atoms in this fragment
-						int m = MatrixValues.Indices[ KeySet.OrderSet[SubOrder][j] ][k];
-						//cout << "Current index is " << k << "/" << m << "." << endl;
-						if (m != -1) { // if it's not an added hydrogen
-							for (int l=0;l<RowCounter[ KeySet.OrderSet[Order][CurrentFragment] ];l++) { // look for the corresponding index in the current fragment
-								//cout << "Comparing " << m << " with " << MatrixValues.Indices[ KeySet.OrderSet[Order][CurrentFragment] ][l] << "." << endl;
-								if (m == MatrixValues.Indices[ KeySet.OrderSet[Order][CurrentFragment] ][l]) {
-									m = l;
-									break;
-								}
-							}
-							//cout << "Corresponding index in CurrentFragment is " << m << "." << endl;
-							if (m > RowCounter[ KeySet.OrderSet[Order][CurrentFragment] ]) {
-								cerr << "In fragment No. " << KeySet.OrderSet[Order][CurrentFragment]	 << " current force index " << m << " is greater than " << RowCounter[ KeySet.OrderSet[Order][CurrentFragment] ] << "!" << endl;
-								return false;
-							}
-							if (Order == SubOrder) { // equal order is always copy from Energies
-								for(int l=ColumnCounter;l--;) // then adds/subtract each column
-									Matrix[ KeySet.OrderSet[Order][CurrentFragment] ][m][l] += MatrixValues.Matrix[ KeySet.OrderSet[SubOrder][j] ][k][l];
-							} else {
-								for(int l=ColumnCounter;l--;)
-									Matrix[ KeySet.OrderSet[Order][CurrentFragment] ][m][l] -= Matrix[ KeySet.OrderSet[SubOrder][j] ][k][l];
-							}
-						}
-						//if ((ColumnCounter>1) && (RowCounter[0]-1 >= 1))
-						 //cout << "Fragments[ KeySet.OrderSet[" << Order << "][" << CurrentFragment << "]=" << KeySet.OrderSet[Order][CurrentFragment] << " ][" << RowCounter[0]-1 << "][" << 1 << "] = " <<	Matrix[ KeySet.OrderSet[Order][CurrentFragment] ][RowCounter[0]-1][1] << endl;
-					}
-				} else {
-					//cout << "Fragment " << KeySet.OrderSet[SubOrder][j] << " is not contained in fragment " << KeySet.OrderSet[Order][CurrentFragment] << "." << endl;
-				}
-			}
-		}
-	 //cout << "Final Fragments[ KeySet.OrderSet[" << Order << "][" << CurrentFragment << "]=" << KeySet.OrderSet[Order][CurrentFragment] << " ][" << KeySet.AtomCounter[0]-1 << "][" << 1 << "] = " <<	Matrix[ KeySet.OrderSet[Order][CurrentFragment] ][KeySet.AtomCounter[0]-1][1] << endl;
-	}
-
-	return true;
+  // go through each order
+  for (int CurrentFragment=0;CurrentFragment<KeySet.FragmentsPerOrder[Order];CurrentFragment++) {
+    //cout << "Current Fragment is " << CurrentFragment << "/" << KeySet.OrderSet[Order][CurrentFragment] << "." << endl;
+    // then go per order through each suborder and pick together all the terms that contain this fragment
+    for(int SubOrder=0;SubOrder<=Order;SubOrder++) { // go through all suborders up to the desired order
+      for (int j=0;j<KeySet.FragmentsPerOrder[SubOrder];j++) { // go through all possible fragments of size suborder
+        if (KeySet.Contains(KeySet.OrderSet[Order][CurrentFragment], KeySet.OrderSet[SubOrder][j])) {
+          //cout << "Current other fragment is " << j << "/" << KeySet.OrderSet[SubOrder][j] << "." << endl;
+          // if the fragment's indices are all in the current fragment
+          for(int k=0;k<RowCounter[ KeySet.OrderSet[SubOrder][j] ];k++) { // go through all atoms in this fragment
+            int m = MatrixValues.Indices[ KeySet.OrderSet[SubOrder][j] ][k];
+            //cout << "Current index is " << k << "/" << m << "." << endl;
+            if (m != -1) { // if it's not an added hydrogen
+              for (int l=0;l<RowCounter[ KeySet.OrderSet[Order][CurrentFragment] ];l++) { // look for the corresponding index in the current fragment
+                //cout << "Comparing " << m << " with " << MatrixValues.Indices[ KeySet.OrderSet[Order][CurrentFragment] ][l] << "." << endl;
+                if (m == MatrixValues.Indices[ KeySet.OrderSet[Order][CurrentFragment] ][l]) {
+                  m = l;
+                  break;
+                }
+              }
+              //cout << "Corresponding index in CurrentFragment is " << m << "." << endl;
+              if (m > RowCounter[ KeySet.OrderSet[Order][CurrentFragment] ]) {
+                cerr << "In fragment No. " << KeySet.OrderSet[Order][CurrentFragment]   << " current force index " << m << " is greater than " << RowCounter[ KeySet.OrderSet[Order][CurrentFragment] ] << "!" << endl;
+                return false;
+              }
+              if (Order == SubOrder) { // equal order is always copy from Energies
+                for(int l=ColumnCounter[ KeySet.OrderSet[SubOrder][j] ];l--;) // then adds/subtract each column 
+                  Matrix[ KeySet.OrderSet[Order][CurrentFragment] ][m][l] += MatrixValues.Matrix[ KeySet.OrderSet[SubOrder][j] ][k][l];
+              } else {
+                for(int l=ColumnCounter[ KeySet.OrderSet[SubOrder][j] ];l--;)
+                  Matrix[ KeySet.OrderSet[Order][CurrentFragment] ][m][l] -= Matrix[ KeySet.OrderSet[SubOrder][j] ][k][l];
+              }
+            }
+            //if ((ColumnCounter[ KeySet.OrderSet[SubOrder][j] ]>1) && (RowCounter[0]-1 >= 1))
+             //cout << "Fragments[ KeySet.OrderSet[" << Order << "][" << CurrentFragment << "]=" << KeySet.OrderSet[Order][CurrentFragment] << " ][" << RowCounter[0]-1 << "][" << 1 << "] = " <<  Matrix[ KeySet.OrderSet[Order][CurrentFragment] ][RowCounter[0]-1][1] << endl;
+          }
+        } else {
+          //cout << "Fragment " << KeySet.OrderSet[SubOrder][j] << " is not contained in fragment " << KeySet.OrderSet[Order][CurrentFragment] << "." << endl;
+        }
+      }
+    }
+   //cout << "Final Fragments[ KeySet.OrderSet[" << Order << "][" << CurrentFragment << "]=" << KeySet.OrderSet[Order][CurrentFragment] << " ][" << KeySet.AtomCounter[0]-1 << "][" << 1 << "] = " <<  Matrix[ KeySet.OrderSet[Order][CurrentFragment] ][KeySet.AtomCounter[0]-1][1] << endl;
+  }
+
+  return true;
 };
 
